/*
 * SGI Audio Library Output Plugin for XMMS
 */
#ifndef SGIAL_H
#define SGIAL_H

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dmedia/audio.h>

#include <gtk/gtk.h>

#include <xmms/plugin.h>
#include <xmms/util.h>
#include <xmms/configfile.h>

extern OutputPlugin op;

void sgial_init(void);
void sgial_about(void);
void sgial_configure(void);

void sgial_get_volume(int *l, int *r);
void sgial_set_volume(int l, int r);

int sgial_playing(void);
int sgial_free(void);
void sgial_write(void *ptr, int length);
void sgial_close(void);
void sgial_flush(int time);
void sgial_pause(short p);
int sgial_open(AFormat fmt, gint rate, gint nch);
int sgial_get_output_time(void);
int sgial_get_written_time(void);
void sgial_set_audio_params(void);

/*
 * Audio Library parameters
 */
struct audiolib_info
{
  ALconfig config;
  ALport port;
  ALvalue *output_devices;
  gint bufsize;
  gint device_count;
  gchar *current_device;
  gint32 current_dev;
  double gainrange, adjusted_mingain, adjusted_maxgain, adjustment;
  int leftgain, rightgain;
  gint frame_size;
};

/*
 * Current audio parameters
 */
struct play_info {
  gint channels;
  int format;
  gint rate;
  gboolean playing;
  gboolean paused;
  gint bitrate;
  gint width;
  long long written_frames;
  long long output_frames; /* for downsampling (to be implemented) */
  gint output_time_offset;
  gint latency;
};

extern struct audiolib_info alinfo;
extern struct play_info pinfo;
extern ConfigFile *cfgfile;
extern gchar *filename;

#endif /* SGIAL_H */





