#include "sgial.h"

/*
 * Write the buffer referenced by ptr to the audio
 * device (length is in bytes)
 */
void sgial_write(void *ptr, gint length)
{
  /*
   * Not if we're paused or not playing
   */
  if(pinfo.paused || !pinfo.playing) {
    return;
  }

  /*
   * Make sure we can queue the frames without
   * dropping any.
   */
  while(sgial_free() < length) {
    xmms_usleep(5000);
  }

  /*
   * Increment bytes written
   * FIXME: implement downsampling
   */
  pinfo.written_frames += length / alinfo.frame_size;
  pinfo.output_frames = pinfo.written_frames;

  /*
   * The actual number of frames we're writing is length / frame size
   */
  alWriteFrames(alinfo.port, (unsigned char *)ptr, length / alinfo.frame_size);

  return;
}

